/*
 * Copyright 2008-2010 Fabien Coeurjoly <fabien.coeurjoly@wanadoo.fr>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  The names of contributors may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 */

#include <proto/dos.h>
#include <clib/macros.h>

#include "input/input.h"

#include "gui/interface.h"
#include "gui.h"

struct MPlayerAppData
{
};

DEFNEW(MPlayerApp)
{
	obj = DoSuperNew(cl, obj,
		    TAG_MORE, INITTAGS);

	return (ULONG)obj;
}

DEFSET(MPlayerApp)
{
	ULONG rc = 0;

	if(mygui->embedded)
	{
		FORTAG(((struct opSet *)msg)->ops_AttrList)
		{
			case MUIA_Application_Iconified:
			{
				if(tag->ti_Data == TRUE)
				{
					// prevent iconification in fullscreen.
					if(mygui->fullscreen) return 0;
				}
			}
			break;
		}
		NEXTTAG
	}

	rc = DOSUPER;
	return rc;
}

BEGINMTABLE2(mplayerappclass)
DECNEW(MPlayerApp)
DECSET(MPlayerApp)
ENDMTABLE

DECSUBCLASS_NC(MUIC_Application, mplayerappclass, MPlayerAppData)
