/*
 * Copyright 2008-2010 Fabien Coeurjoly <fabien.coeurjoly@wanadoo.fr>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  The names of contributors may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 */

#include "gui.h"

ULONG mui_getv(APTR obj, ULONG attr)
{
	ULONG v;

	GetAttr(attr, obj, &v);
	return (v);
}

APTR MakeButton(CONST_STRPTR msg)
{
	APTR obj;

	if ((obj = MUI_MakeObject(MUIO_Button, (IPTR) msg)))
		SetAttrs(obj, MUIA_CycleChain, TRUE, TAG_DONE);

	return obj;
}

APTR MakeCheck(CONST_STRPTR str, ULONG checked)
{
	APTR obj;

	obj = MUI_MakeObject(MUIO_Checkmark, (IPTR) str);

	if (obj)
		SetAttrs(obj,
			MUIA_CycleChain	, TRUE,
			MUIA_Selected	, checked,
			TAG_DONE);

	return (obj);
}

APTR MakeString(CONST_STRPTR def)
{
	return StringObject, StringFrame, MUIA_CycleChain, 1, MUIA_String_Contents, def, TAG_DONE);
}

APTR MakeNumericString(CONST_STRPTR def)
{
	return StringObject,
			StringFrame,
			MUIA_CycleChain, 1,
			MUIA_String_Contents, def,
			MUIA_String_Accept , "0123456879",
			MUIA_String_Integer, 0,
			TAG_DONE);
}
