/*
 * Copyright 2008-2010 Fabien Coeurjoly <fabien.coeurjoly@wanadoo.fr>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  The names of contributors may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 */

#ifndef __THREAD_H__
#define __THREAD_H__

#include "global.h"

#include <exec/exec.h>
#include <exec/types.h>
#include <dos/dos.h>

struct Thread
{
	struct startupmsg *msg;
	struct startupmsg *reply;
	struct MsgPort *replyport;
	struct Process * task;
	ULONG  finished;
};

struct startupmsg
{
	struct Message msg;
	APTR obj;
	APTR arg;
};

struct Thread *	RunThread(int (*func) (void), const char * threadname, APTR obj, APTR arg, ULONG argsize);
int CheckThreadAbort(void);
void SignalThread(struct Thread * t);
void WaitForThread(struct Thread * t);

#endif
