/*
 * Copyright 2008-2010 Fabien Coeurjoly <fabien.coeurjoly@wanadoo.fr>
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  The names of contributors may not be used to endorse or promote products
 *     derived from this software without specific prior written permission.
 *
 */

#include <clib/macros.h>
#include <proto/dos.h>

#include "gui/interface.h"
#include "gui.h"

/******************************************************************
 * volumesliderclass
 *****************************************************************/

struct VolumeSliderData
{
	TEXT buffer[16];
};

DEFNEW(VolumeSlider)
{
	obj = DoSuperNew(cl, obj,
		MUIA_Numeric_Min,  0,
		MUIA_Numeric_Max,  100,
		MUIA_Slider_Min,   0,
		MUIA_Slider_Max,   100,
		MUIA_Slider_Level, 100,
		TAG_MORE, INITTAGS,
	End;

	return (ULONG)obj;
}

DEFMMETHOD(Numeric_Stringify)
{
	struct VolumeSliderData *data = INST_DATA(cl, obj);

	snprintf(data->buffer, sizeof(data->buffer), " ");

	return ((ULONG)data->buffer);
}

DEFMMETHOD(AskMinMax)
{
	ULONG maxwidth, defwidth, minwidth;

	DOSUPER;

	maxwidth = 50;
	defwidth = 50;
	minwidth = 50;

	msg->MinMaxInfo->MinWidth  = minwidth;
	msg->MinMaxInfo->DefWidth  = defwidth;
	msg->MinMaxInfo->MaxWidth  = maxwidth;

	return 0;
}

BEGINMTABLE2(volumesliderclass)
DECNEW(VolumeSlider)
DECMMETHOD(AskMinMax)
DECMMETHOD(Numeric_Stringify)
ENDMTABLE

DECSUBCLASS_NC(MUIC_Slider, volumesliderclass, VolumeSliderData)

